> ## Documentation Index
> Fetch the complete documentation index at: https://docs.switch.vaultera.co/llms.txt
> Use this file to discover all available pages before exploring further.

# Payments - Create

> **Creates a payment object when amount and currency are passed.**

This API is also used to create a mandate by passing the `mandate_object`.

Depending on the user journey you wish to achieve, you may opt to complete all the steps in a single request **by attaching a payment method, setting `confirm=true` and `capture_method = automatic`** in the *Payments/Create API* request.

Otherwise, To completely process a payment you will have to **create a payment, attach a payment method, confirm and capture funds**. For that you could use the following sequence of API requests -

1. Payments - Create

2. Payments - Update

3. Payments - Confirm

4. Payments - Capture.

You will require the 'API - Key' from the Vaultera Switch dashboard to make the first call, and use the 'client secret' returned in this API along with your 'publishable key' to make subsequent API calls from your client.

This page lists the various combinations in which the Payments - Create API can be used and the details about the various fields in the requests and responses.

<Tip> Use the dropdown on the top right corner of the code snippet to try out different payment scenarios. </Tip>


## OpenAPI

````yaml openapi_spec post /payments
openapi: 3.0.3
info:
  title: Vaultera Switch - API Documentation
  description: >

    ## Get started


    Vaultera Switch provides a collection of APIs that enable you to process and
    manage payments.

    Our APIs accept and return JSON in the HTTP body, and return standard HTTP
    response codes.


    You can consume the APIs directly using your favorite HTTP/REST library.


    We have a testing environment referred to "sandbox", which you can setup to
    test API calls without

    affecting production data.

    Currently, our sandbox environment is live while our production environment
    is under development

    and will be available soon.

    You can sign up on our Dashboard to get API keys to access Vaultera Switch
    API.


    ### Environment


    Use the following base URLs when making requests to the APIs:


    | Environment   |  Base URL                          |

    |---------------|------------------------------------|

    | Sandbox       | <https://sandbox.test.switch.vaultera.co>   |

    | Production    | <https://api.test.switch.vaultera.co>       |


    ## Authentication


    When you sign up on our [dashboard](https://app.test.switch.vaultera.co) and
    create a merchant

    account, you are given a secret key (also referred as api-key) and a
    publishable key.

    You may authenticate all API requests with Vaultera Switch server by
    providing the appropriate key in

    the request Authorization header.


    | Key             | 
    Description                                                                                 
    |

    |-----------------|-----------------------------------------------------------------------------------------------|

    | api-key         | Private key. Used to authenticate all API requests from
    your merchant server                  |

    | publishable key | Unique identifier for your account. Used to authenticate
    API requests from your app's client  |


    Never share your secret api keys. Keep them guarded and secure.
  contact:
    name: Vaultera Switch Support
    url: https://vaultera.co
    email: support@vaultera.co
  license:
    name: Apache-2.0
  version: 0.1.0
servers:
  - url: https://api.test.switch.vaultera.co
    description: Sandbox Environment
  - url: https://api.switch.vaultera.co
    description: Sandbox Environment
security: []
tags:
  - name: Merchant Account
    description: Create and manage merchant accounts
  - name: Profile
    description: Create and manage profiles
  - name: Merchant Connector Account
    description: Create and manage merchant connector accounts
  - name: Payments
    description: Create and manage one-time payments, recurring payments and mandates
  - name: Refunds
    description: Create and manage refunds for successful payments
  - name: Mandates
    description: Manage mandates
  - name: Customers
    description: Create and manage customers
  - name: Payment Methods
    description: Create and manage payment methods of customers
  - name: Disputes
    description: Manage disputes
  - name: API Key
    description: Create and manage API Keys
  - name: Payouts
    description: Create and manage payouts
  - name: payment link
    description: Create payment link
  - name: Routing
    description: Create and manage routing configurations
  - name: Event
    description: Manage events
paths:
  /payments:
    post:
      tags:
        - Payments
      summary: Payments - Create
      description: >-
        **Creates a payment object when amount and currency are passed.**


        This API is also used to create a mandate by passing the
        `mandate_object`.


        Depending on the user journey you wish to achieve, you may opt to
        complete all the steps in a single request **by attaching a payment
        method, setting `confirm=true` and `capture_method = automatic`** in the
        *Payments/Create API* request.


        Otherwise, To completely process a payment you will have to **create a
        payment, attach a payment method, confirm and capture funds**. For that
        you could use the following sequence of API requests -


        1. Payments - Create


        2. Payments - Update


        3. Payments - Confirm


        4. Payments - Capture.


        You will require the 'API - Key' from the Vaultera Switch dashboard to
        make the first call, and use the 'client secret' returned in this API
        along with your 'publishable key' to make subsequent API calls from your
        client.


        This page lists the various combinations in which the Payments - Create
        API can be used and the details about the various fields in the requests
        and responses.
      operationId: Create a Payment
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/PaymentsCreateRequest'
            examples:
              Create a 3DS payment:
                value:
                  amount: 6540
                  authentication_type: three_ds
                  currency: USD
              Create a manual capture payment:
                value:
                  amount: 6540
                  billing:
                    address:
                      city: San Fransico
                      country: US
                      first_name: joseph
                      last_name: Doe
                      line1: '1467'
                      line2: Harrison Street
                      line3: Harrison Street
                      state: California
                      zip: '94122'
                    phone:
                      country_code: '+91'
                      number: '9123456789'
                  currency: USD
                  customer:
                    id: cus_abcdefgh
              Create a payment and save the card:
                value:
                  amount: 6540
                  authentication_type: no_three_ds
                  confirm: true
                  currency: USD
                  customer_acceptance:
                    acceptance_type: online
                    accepted_at: '1963-05-03T04:07:52.723Z'
                    online:
                      ip_address: 127.0.0.1
                      user_agent: amet irure esse
                  customer_id: StripeCustomer123
                  payment_method: card
                  payment_method_data:
                    card:
                      card_cvc: '123'
                      card_exp_month: '10'
                      card_exp_year: '25'
                      card_holder_name: joseph Doe
                      card_number: '4242424242424242'
                  setup_future_usage: off_session
              Create a payment using an already saved card's token:
                value:
                  amount: 6540
                  card_cvc: '123'
                  client_secret: '{{client_secret}}'
                  confirm: true
                  currency: USD
                  payment_method: card
                  payment_token: '{{payment_token}}'
              Create a payment with customer details and metadata:
                value:
                  amount: 6540
                  currency: USD
                  customer:
                    email: john@example.com
                    id: cus_abcdefgh
                    name: John Dough
                    phone: '9123456789'
                  description: Its my first payment request
                  metadata:
                    udf1: some-value
                    udf2: some-value
                  payment_id: abcdefghijklmnopqrstuvwxyz
                  statement_descriptor_name: joseph
                  statement_descriptor_suffix: JS
              Create a payment with minimal fields:
                value:
                  amount: 6540
                  currency: USD
              Create a recurring payment with mandate_id:
                value:
                  amount: 6540
                  authentication_type: no_three_ds
                  confirm: true
                  currency: USD
                  customer_id: StripeCustomer
                  mandate_id: '{{mandate_id}}'
                  off_session: true
              Create a setup mandate payment:
                value:
                  amount: 6540
                  authentication_type: no_three_ds
                  confirm: true
                  currency: USD
                  customer_acceptance:
                    acceptance_type: online
                    accepted_at: '1963-05-03T04:07:52.723Z'
                    online:
                      ip_address: 127.0.0.1
                      user_agent: amet irure esse
                  customer_id: StripeCustomer123
                  mandate_data:
                    customer_acceptance:
                      acceptance_type: online
                      accepted_at: '1963-05-03T04:07:52.723Z'
                      online:
                        ip_address: 127.0.0.1
                        user_agent: amet irure esse
                    mandate_type:
                      single_use:
                        amount: 6540
                        currency: USD
                  payment_method: card
                  payment_method_data:
                    card:
                      card_cvc: '123'
                      card_exp_month: '10'
                      card_exp_year: '25'
                      card_holder_name: joseph Doe
                      card_number: '4242424242424242'
                  setup_future_usage: off_session
        required: true
      responses:
        '200':
          description: Payment created
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/PaymentsCreateResponseOpenApi'
        '400':
          description: Missing Mandatory fields
      security:
        - api_key: []
components:
  schemas:
    PaymentsCreateRequest:
      type: object
      required:
        - amount
        - currency
      properties:
        amount:
          type: integer
          format: int64
          description: >-
            The payment amount. Amount for the payment in the lowest
            denomination of the currency, (i.e) in cents for USD denomination,
            in yen for JPY denomination etc. E.g., Pass 100 to charge $1.00 and
            1 for 1¥ since ¥ is a zero-decimal currency. Read more about [the
            Decimal and Non-Decimal
            Currencies](https://github.com/juspay/vaultera
            switch/wiki/Decimal-and-Non%E2%80%90Decimal-Currencies)
          minimum: 0
        order_tax_amount:
          type: integer
          format: int64
          description: Total tax amount applicable to the order
          example: 6540
          nullable: true
        currency:
          $ref: '#/components/schemas/Currency'
        amount_to_capture:
          type: integer
          format: int64
          description: >-
            The Amount to be captured / debited from the users payment method.
            It shall be in lowest denomination of the currency. (i.e) in cents
            for USD denomination, in paisa for INR denomination etc., If not
            provided, the default amount_to_capture will be the payment amount.
            Also, it must be less than or equal to the original payment account.
          example: 6540
          nullable: true
        shipping_cost:
          type: integer
          format: int64
          description: >-
            The shipping cost for the payment. This is required for tax
            calculation in some regions.
          example: 6540
          nullable: true
        payment_id:
          type: string
          description: >-
            Unique identifier for the payment. This ensures idempotency for
            multiple payments

            that have been done by a single merchant. The value for this field
            can be specified in the request, it will be auto generated otherwise
            and returned in the API response.
          example: pay_mbabizu24mvu3mela5njyhpit4
          nullable: true
          maxLength: 30
          minLength: 30
        routing:
          allOf:
            - $ref: '#/components/schemas/StraightThroughAlgorithm'
          nullable: true
        connector:
          type: array
          items:
            $ref: '#/components/schemas/Connector'
          description: >-
            This allows to manually select a connector with which the payment
            can go through.
          example:
            - stripe
            - adyen
          nullable: true
        capture_method:
          allOf:
            - $ref: '#/components/schemas/CaptureMethod'
          nullable: true
        authentication_type:
          allOf:
            - $ref: '#/components/schemas/AuthenticationType'
          default: three_ds
          nullable: true
        billing:
          allOf:
            - $ref: '#/components/schemas/Address'
          nullable: true
        confirm:
          type: boolean
          description: >-
            Whether to confirm the payment (if applicable). It can be used to
            completely process a payment by attaching a payment method, setting
            `confirm=true` and `capture_method = automatic` in the
            *Payments/Create API* request itself.
          default: false
          example: true
          nullable: true
        customer:
          allOf:
            - $ref: '#/components/schemas/CustomerDetails'
          nullable: true
        customer_id:
          type: string
          description: The identifier for the customer
          example: cus_y3oqhf46pyzuxjbcn2giaqnb44
          nullable: true
          maxLength: 64
          minLength: 1
        off_session:
          type: boolean
          description: >-
            Set to true to indicate that the customer is not in your checkout
            flow during this payment, and therefore is unable to authenticate.
            This parameter is intended for scenarios where you collect card
            details and charge them later. When making a recurring payment by
            passing a mandate_id, this parameter is mandatory
          example: true
          nullable: true
        description:
          type: string
          description: A description for the payment
          example: It's my first payment request
          nullable: true
        return_url:
          type: string
          description: >-
            The URL to which you want the user to be redirected after the
            completion of the payment operation
          example: https://vaultera.co
          nullable: true
        setup_future_usage:
          allOf:
            - $ref: '#/components/schemas/FutureUsage'
          nullable: true
        payment_method_data:
          allOf:
            - $ref: '#/components/schemas/PaymentMethodDataRequest'
          nullable: true
        payment_method:
          allOf:
            - $ref: '#/components/schemas/PaymentMethod'
          nullable: true
        payment_token:
          type: string
          description: >-
            As Vaultera Switch tokenises the sensitive details about the
            payments method, it provides the payment_token as a reference to a
            stored payment method, ensuring that the sensitive details are not
            exposed in any manner.
          example: 187282ab-40ef-47a9-9206-5099ba31e432
          nullable: true
        shipping:
          allOf:
            - $ref: '#/components/schemas/Address'
          nullable: true
        statement_descriptor_name:
          type: string
          description: >-
            For non-card charges, you can use this value as the complete
            description that appears on your customers’ statements. Must contain
            at least one letter, maximum 22 characters.
          example: Vaultera Switch Router
          nullable: true
          maxLength: 255
        statement_descriptor_suffix:
          type: string
          description: >-
            Provides information about a card payment that customers see on
            their statements. Concatenated with the prefix (shortened
            descriptor) or statement descriptor that’s set on the account to
            form the complete statement descriptor. Maximum 22 characters for
            the concatenated descriptor.
          example: Payment for shoes purchase
          nullable: true
          maxLength: 255
        order_details:
          type: array
          items:
            $ref: '#/components/schemas/OrderDetailsWithAmount'
          description: >-
            Use this object to capture the details about the different products
            for which the payment is being made. The sum of amount across
            different products here should be equal to the overall payment
            amount
          example: |-
            [{
                    "product_name": "Apple iPhone 16",
                    "quantity": 1,
                    "amount" : 69000
                    "product_img_link" : "https://dummy-img-link.com"
                }]
          nullable: true
        mandate_data:
          allOf:
            - $ref: '#/components/schemas/MandateData'
          nullable: true
        customer_acceptance:
          allOf:
            - $ref: '#/components/schemas/CustomerAcceptance'
          nullable: true
        mandate_id:
          type: string
          description: >-
            A unique identifier to link the payment to a mandate. To do
            Recurring payments after a mandate has been created, pass the
            mandate_id instead of payment_method_data
          example: mandate_iwer89rnjef349dni3
          nullable: true
          maxLength: 255
        browser_info:
          allOf:
            - $ref: '#/components/schemas/BrowserInformation'
          nullable: true
        payment_experience:
          allOf:
            - $ref: '#/components/schemas/PaymentExperience'
          nullable: true
        payment_method_type:
          allOf:
            - $ref: '#/components/schemas/PaymentMethodType'
          nullable: true
        business_country:
          allOf:
            - $ref: '#/components/schemas/CountryAlpha2'
          nullable: true
        business_label:
          type: string
          description: |-
            Business label of the merchant for this payment.
            To be deprecated soon. Pass the profile_id instead
          example: food
          nullable: true
        merchant_connector_details:
          allOf:
            - $ref: '#/components/schemas/MerchantConnectorDetailsWrap'
          nullable: true
        allowed_payment_method_types:
          type: array
          items:
            $ref: '#/components/schemas/PaymentMethodType'
          description: >-
            Use this parameter to restrict the Payment Method Types to show for
            a given PaymentIntent
          nullable: true
        metadata:
          type: object
          description: >-
            You can specify up to 50 keys, with key names up to 40 characters
            long and values up to 500 characters long. Metadata is useful for
            storing additional, structured information on an object.
          nullable: true
        connector_metadata:
          allOf:
            - $ref: '#/components/schemas/ConnectorMetadata'
          nullable: true
        payment_link:
          type: boolean
          description: >-
            Whether to generate the payment link for this payment or not (if
            applicable)
          default: false
          example: true
          nullable: true
        payment_link_config:
          allOf:
            - $ref: '#/components/schemas/PaymentCreatePaymentLinkConfig'
          nullable: true
        payment_link_config_id:
          type: string
          description: >-
            Custom payment link config id set at business profile, send only if
            business_specific_configs is configured
          nullable: true
        profile_id:
          type: string
          description: >-
            The business profile to be used for this payment, if not passed the
            default business profile associated with the merchant account will
            be used. It is mandatory in case multiple business profiles have
            been set up.
          nullable: true
        surcharge_details:
          allOf:
            - $ref: '#/components/schemas/RequestSurchargeDetails'
          nullable: true
        payment_type:
          allOf:
            - $ref: '#/components/schemas/PaymentType'
          nullable: true
        request_incremental_authorization:
          type: boolean
          description: >-
            Request an incremental authorization, i.e., increase the authorized
            amount on a confirmed payment before you capture it.
          nullable: true
        session_expiry:
          type: integer
          format: int32
          description: >-
            Will be used to expire client secret after certain amount of time to
            be supplied in seconds

            (900) for 15 mins
          example: 900
          nullable: true
          minimum: 0
        frm_metadata:
          type: object
          description: >-
            Additional data related to some frm(Fraud Risk Management)
            connectors
          nullable: true
        request_external_three_ds_authentication:
          type: boolean
          description: Whether to perform external authentication (if applicable)
          example: true
          nullable: true
        recurring_details:
          allOf:
            - $ref: '#/components/schemas/RecurringDetails'
          nullable: true
        split_payments:
          allOf:
            - $ref: '#/components/schemas/SplitPaymentsRequest'
          nullable: true
        request_extended_authorization:
          type: boolean
          description: >-
            Optional boolean value to extent authorization period of this
            payment


            capture method must be manual or manual_multiple
          default: false
          nullable: true
        merchant_order_reference_id:
          type: string
          description: >-
            Merchant's identifier for the payment/invoice. This will be sent to
            the connector

            if the connector provides support to accept multiple reference ids.

            In case the connector supports only one reference id, Vaultera
            Switch's Payment ID will be sent as reference.
          example: Custom_Order_id_123
          nullable: true
          maxLength: 255
        skip_external_tax_calculation:
          type: boolean
          description: Whether to calculate tax for this payment intent
          nullable: true
        psd2_sca_exemption_type:
          allOf:
            - $ref: '#/components/schemas/ScaExemptionType'
          nullable: true
        ctp_service_details:
          allOf:
            - $ref: '#/components/schemas/CtpServiceDetails'
          nullable: true
        force_3ds_challenge:
          type: boolean
          description: Indicates if 3ds challenge is forced
          nullable: true
        threeds_method_comp_ind:
          allOf:
            - $ref: '#/components/schemas/ThreeDsCompletionIndicator'
          nullable: true
    PaymentsCreateResponseOpenApi:
      type: object
      required:
        - payment_id
        - merchant_id
        - status
        - amount
        - net_amount
        - amount_capturable
        - currency
        - payment_method
        - attempt_count
      properties:
        payment_id:
          type: string
          description: >-
            Unique identifier for the payment. This ensures idempotency for
            multiple payments

            that have been done by a single merchant.
          example: pay_mbabizu24mvu3mela5njyhpit4
          maxLength: 30
          minLength: 30
        merchant_id:
          type: string
          description: >-
            This is an identifier for the merchant account. This is inferred
            from the API key

            provided during the request
          example: merchant_1668273825
          maxLength: 255
        status:
          allOf:
            - $ref: '#/components/schemas/IntentStatus'
          default: requires_confirmation
        amount:
          type: integer
          format: int64
          description: >-
            The payment amount. Amount for the payment in lowest denomination of
            the currency. (i.e) in cents for USD denomination, in paisa for INR
            denomination etc.,
          example: 6540
        net_amount:
          type: integer
          format: int64
          description: >-
            The payment net amount. net_amount = amount +
            surcharge_details.surcharge_amount + surcharge_details.tax_amount +
            shipping_cost + order_tax_amount,

            If no surcharge_details, shipping_cost, order_tax_amount, net_amount
            = amount
          example: 6540
        shipping_cost:
          type: integer
          format: int64
          description: The shipping cost for the payment.
          example: 6540
          nullable: true
        amount_capturable:
          type: integer
          format: int64
          description: The maximum amount that could be captured from the payment
          example: 6540
          minimum: 100
        amount_received:
          type: integer
          format: int64
          description: >-
            The amount which is already captured from the payment, this helps in
            the cases where merchants can't capture all capturable amount at
            once.
          example: 6540
          nullable: true
        connector:
          type: string
          description: The connector used for the payment
          example: stripe
          nullable: true
        client_secret:
          type: string
          description: It's a token used for client side verification.
          example: pay_U42c409qyHwOkWo3vK60_secret_el9ksDkiB8hi6j9N78yo
          nullable: true
        created:
          type: string
          format: date-time
          description: Time when the payment was created
          example: '2022-09-10T10:11:12Z'
          nullable: true
        currency:
          $ref: '#/components/schemas/Currency'
        customer_id:
          type: string
          description: >-
            The identifier for the customer object. If not provided the customer
            ID will be autogenerated.

            This field will be deprecated soon. Please refer to `customer.id`
          deprecated: true
          example: cus_y3oqhf46pyzuxjbcn2giaqnb44
          nullable: true
          maxLength: 64
          minLength: 1
        description:
          type: string
          description: A description of the payment
          example: It's my first payment request
          nullable: true
        refunds:
          type: array
          items:
            $ref: '#/components/schemas/RefundResponse'
          description: >-
            List of refunds that happened on this intent, as same payment intent
            can have multiple refund requests depending on the nature of order
          nullable: true
        disputes:
          type: array
          items:
            $ref: '#/components/schemas/DisputeResponsePaymentsRetrieve'
          description: List of disputes that happened on this intent
          nullable: true
        attempts:
          type: array
          items:
            $ref: '#/components/schemas/PaymentAttemptResponse'
          description: List of attempts that happened on this intent
          nullable: true
        captures:
          type: array
          items:
            $ref: '#/components/schemas/CaptureResponse'
          description: List of captures done on latest attempt
          nullable: true
        mandate_id:
          type: string
          description: >-
            A unique identifier to link the payment to a mandate, can be used
            instead of payment_method_data, in case of setting up recurring
            payments
          example: mandate_iwer89rnjef349dni3
          nullable: true
          maxLength: 255
        mandate_data:
          allOf:
            - $ref: '#/components/schemas/MandateData'
          nullable: true
        setup_future_usage:
          allOf:
            - $ref: '#/components/schemas/FutureUsage'
          nullable: true
        off_session:
          type: boolean
          description: >-
            Set to true to indicate that the customer is not in your checkout
            flow during this payment, and therefore is unable to authenticate.
            This parameter is intended for scenarios where you collect card
            details and charge them later. This parameter can only be used with
            confirm=true.
          example: true
          nullable: true
        capture_method:
          allOf:
            - $ref: '#/components/schemas/CaptureMethod'
          nullable: true
        payment_method:
          $ref: '#/components/schemas/PaymentMethod'
        payment_method_data:
          allOf:
            - $ref: '#/components/schemas/PaymentMethodDataResponseWithBilling'
          nullable: true
        payment_token:
          type: string
          description: Provide a reference to a stored payment method
          example: 187282ab-40ef-47a9-9206-5099ba31e432
          nullable: true
        shipping:
          allOf:
            - $ref: '#/components/schemas/Address'
          nullable: true
        billing:
          allOf:
            - $ref: '#/components/schemas/Address'
          nullable: true
        order_details:
          type: array
          items:
            $ref: '#/components/schemas/OrderDetailsWithAmount'
          description: >-
            Information about the product , quantity and amount for connectors.
            (e.g. Klarna)
          example: |-
            [{
                    "product_name": "gillete creme",
                    "quantity": 15,
                    "amount" : 900
                }]
          nullable: true
        email:
          type: string
          description: >-
            description: The customer's email address

            This field will be deprecated soon. Please refer to `customer.email`
            object
          deprecated: true
          example: johntest@test.com
          nullable: true
          maxLength: 255
        name:
          type: string
          description: >-
            description: The customer's name

            This field will be deprecated soon. Please refer to `customer.name`
            object
          deprecated: true
          example: John Test
          nullable: true
          maxLength: 255
        phone:
          type: string
          description: >-
            The customer's phone number

            This field will be deprecated soon. Please refer to `customer.phone`
            object
          deprecated: true
          example: '9123456789'
          nullable: true
          maxLength: 255
        return_url:
          type: string
          description: The URL to redirect after the completion of the operation
          example: https://vaultera.co
          nullable: true
        authentication_type:
          allOf:
            - $ref: '#/components/schemas/AuthenticationType'
          default: three_ds
          nullable: true
        statement_descriptor_name:
          type: string
          description: >-
            For non-card charges, you can use this value as the complete
            description that appears on your customers’ statements. Must contain
            at least one letter, maximum 22 characters.
          example: Vaultera Switch Router
          nullable: true
          maxLength: 255
        statement_descriptor_suffix:
          type: string
          description: >-
            Provides information about a card payment that customers see on
            their statements. Concatenated with the prefix (shortened
            descriptor) or statement descriptor that’s set on the account to
            form the complete statement descriptor. Maximum 255 characters for
            the concatenated descriptor.
          example: Payment for shoes purchase
          nullable: true
          maxLength: 255
        next_action:
          allOf:
            - $ref: '#/components/schemas/NextActionData'
          nullable: true
        cancellation_reason:
          type: string
          description: If the payment was cancelled the reason will be provided here
          nullable: true
        error_code:
          type: string
          description: >-
            If there was an error while calling the connectors the code is
            received here
          example: E0001
          nullable: true
        error_message:
          type: string
          description: >-
            If there was an error while calling the connector the error message
            is received here
          example: Failed while verifying the card
          nullable: true
        payment_experience:
          allOf:
            - $ref: '#/components/schemas/PaymentExperience'
          nullable: true
        payment_method_type:
          allOf:
            - $ref: '#/components/schemas/PaymentMethodType'
          nullable: true
        connector_label:
          type: string
          description: >-
            The connector used for this payment along with the country and
            business details
          example: stripe_US_food
          nullable: true
        business_country:
          allOf:
            - $ref: '#/components/schemas/CountryAlpha2'
          nullable: true
        business_label:
          type: string
          description: The business label of merchant for this payment
          nullable: true
        business_sub_label:
          type: string
          description: The business_sub_label for this payment
          nullable: true
        allowed_payment_method_types:
          type: array
          items:
            $ref: '#/components/schemas/PaymentMethodType'
          description: Allowed Payment Method Types for a given PaymentIntent
          nullable: true
        ephemeral_key:
          allOf:
            - $ref: '#/components/schemas/EphemeralKeyCreateResponse'
          nullable: true
        manual_retry_allowed:
          type: boolean
          description: >-
            If true the payment can be retried with same or different payment
            method which means the confirm call can be made again.
          nullable: true
        connector_transaction_id:
          type: string
          description: A unique identifier for a payment provided by the connector
          example: 993672945374576J
          nullable: true
        frm_message:
          allOf:
            - $ref: '#/components/schemas/FrmMessage'
          nullable: true
        metadata:
          type: object
          description: >-
            You can specify up to 50 keys, with key names up to 40 characters
            long and values up to 500 characters long. Metadata is useful for
            storing additional, structured information on an object.
          nullable: true
        connector_metadata:
          allOf:
            - $ref: '#/components/schemas/ConnectorMetadata'
          nullable: true
        feature_metadata:
          allOf:
            - $ref: '#/components/schemas/FeatureMetadata'
          nullable: true
        reference_id:
          type: string
          description: reference(Identifier) to the payment at connector side
          example: 993672945374576J
          nullable: true
        payment_link:
          allOf:
            - $ref: '#/components/schemas/PaymentLinkResponse'
          nullable: true
        profile_id:
          type: string
          description: The business profile that is associated with this payment
          nullable: true
        surcharge_details:
          allOf:
            - $ref: '#/components/schemas/RequestSurchargeDetails'
          nullable: true
        attempt_count:
          type: integer
          format: int32
          description: Total number of attempts associated with this payment
        merchant_decision:
          type: string
          description: >-
            Denotes the action(approve or reject) taken by merchant in case of
            manual review. Manual review can occur when the transaction is
            marked as risky by the frm_processor, payment processor or when
            there is underpayment/over payment incase of crypto payment
          nullable: true
        merchant_connector_id:
          type: string
          description: >-
            Identifier of the connector ( merchant connector account ) which was
            chosen to make the payment
          nullable: true
        incremental_authorization_allowed:
          type: boolean
          description: >-
            If true, incremental authorization can be performed on this payment,
            in case the funds authorized initially fall short.
          nullable: true
        authorization_count:
          type: integer
          format: int32
          description: >-
            Total number of authorizations happened in an
            incremental_authorization payment
          nullable: true
        incremental_authorizations:
          type: array
          items:
            $ref: '#/components/schemas/IncrementalAuthorizationResponse'
          description: List of incremental authorizations happened to the payment
          nullable: true
        external_authentication_details:
          allOf:
            - $ref: '#/components/schemas/ExternalAuthenticationDetailsResponse'
          nullable: true
        external_3ds_authentication_attempted:
          type: boolean
          description: Flag indicating if external 3ds authentication is made or not
          nullable: true
        expires_on:
          type: string
          format: date-time
          description: Date Time for expiry of the payment
          example: '2022-09-10T10:11:12Z'
          nullable: true
        fingerprint:
          type: string
          description: |-
            Payment Fingerprint, to identify a particular card.
            It is a 20 character long alphanumeric code.
          nullable: true
        browser_info:
          allOf:
            - $ref: '#/components/schemas/BrowserInformation'
          nullable: true
        payment_method_id:
          type: string
          description: Identifier for Payment Method used for the payment
          nullable: true
        payment_method_status:
          allOf:
            - $ref: '#/components/schemas/PaymentMethodStatus'
          nullable: true
        updated:
          type: string
          format: date-time
          description: Date time at which payment was updated
          example: '2022-09-10T10:11:12Z'
          nullable: true
        split_payments:
          allOf:
            - $ref: '#/components/schemas/ConnectorChargeResponseData'
          nullable: true
        frm_metadata:
          type: object
          description: >-
            You can specify up to 50 keys, with key names up to 40 characters
            long and values up to 500 characters long. FRM Metadata is useful
            for storing additional, structured information on an object related
            to FRM.
          nullable: true
        extended_authorization_applied:
          type: boolean
          description: >-
            flag that indicates if extended authorization is applied on this
            payment or not
          nullable: true
        capture_before:
          type: string
          format: date-time
          description: date and time after which this payment cannot be captured
          nullable: true
        merchant_order_reference_id:
          type: string
          description: >-
            Merchant's identifier for the payment/invoice. This will be sent to
            the connector

            if the connector provides support to accept multiple reference ids.

            In case the connector supports only one reference id, Vaultera
            Switch's Payment ID will be sent as reference.
          example: Custom_Order_id_123
          nullable: true
          maxLength: 255
        order_tax_amount:
          allOf:
            - $ref: '#/components/schemas/MinorUnit'
          nullable: true
        connector_mandate_id:
          type: string
          description: Connector Identifier for the payment method
          nullable: true
        card_discovery:
          allOf:
            - $ref: '#/components/schemas/CardDiscovery'
          nullable: true
        force_3ds_challenge:
          type: boolean
          description: Indicates if 3ds challenge is forced
          nullable: true
        force_3ds_challenge_trigger:
          type: boolean
          description: Indicates if 3ds challenge is triggered
          nullable: true
        issuer_error_code:
          type: string
          description: Error code received from the issuer in case of failed payments
          nullable: true
        issuer_error_message:
          type: string
          description: Error message received from the issuer in case of failed payments
          nullable: true
    Currency:
      type: string
      description: >-
        The three letter ISO currency code in uppercase. Eg: 'USD' for the
        United States Dollar.
      enum:
        - AED
        - AFN
        - ALL
        - AMD
        - ANG
        - AOA
        - ARS
        - AUD
        - AWG
        - AZN
        - BAM
        - BBD
        - BDT
        - BGN
        - BHD
        - BIF
        - BMD
        - BND
        - BOB
        - BRL
        - BSD
        - BTN
        - BWP
        - BYN
        - BZD
        - CAD
        - CDF
        - CHF
        - CLF
        - CLP
        - CNY
        - COP
        - CRC
        - CUC
        - CUP
        - CVE
        - CZK
        - DJF
        - DKK
        - DOP
        - DZD
        - EGP
        - ERN
        - ETB
        - EUR
        - FJD
        - FKP
        - GBP
        - GEL
        - GHS
        - GIP
        - GMD
        - GNF
        - GTQ
        - GYD
        - HKD
        - HNL
        - HRK
        - HTG
        - HUF
        - IDR
        - ILS
        - INR
        - IQD
        - IRR
        - ISK
        - JMD
        - JOD
        - JPY
        - KES
        - KGS
        - KHR
        - KMF
        - KPW
        - KRW
        - KWD
        - KYD
        - KZT
        - LAK
        - LBP
        - LKR
        - LRD
        - LSL
        - LYD
        - MAD
        - MDL
        - MGA
        - MKD
        - MMK
        - MNT
        - MOP
        - MRU
        - MUR
        - MVR
        - MWK
        - MXN
        - MYR
        - MZN
        - NAD
        - NGN
        - NIO
        - NOK
        - NPR
        - NZD
        - OMR
        - PAB
        - PEN
        - PGK
        - PHP
        - PKR
        - PLN
        - PYG
        - QAR
        - RON
        - RSD
        - RUB
        - RWF
        - SAR
        - SBD
        - SCR
        - SDG
        - SEK
        - SGD
        - SHP
        - SLE
        - SLL
        - SOS
        - SRD
        - SSP
        - STD
        - STN
        - SVC
        - SYP
        - SZL
        - THB
        - TJS
        - TMT
        - TND
        - TOP
        - TRY
        - TTD
        - TWD
        - TZS
        - UAH
        - UGX
        - USD
        - UYU
        - UZS
        - VES
        - VND
        - VUV
        - WST
        - XAF
        - XCD
        - XOF
        - XPF
        - YER
        - ZAR
        - ZMW
        - ZWL
    StraightThroughAlgorithm:
      oneOf:
        - type: object
          title: Single
          required:
            - type
            - data
          properties:
            type:
              type: string
              enum:
                - single
            data:
              $ref: '#/components/schemas/RoutableConnectorChoice'
        - type: object
          title: Priority
          required:
            - type
            - data
          properties:
            type:
              type: string
              enum:
                - priority
            data:
              type: array
              items:
                $ref: '#/components/schemas/RoutableConnectorChoice'
        - type: object
          title: VolumeSplit
          required:
            - type
            - data
          properties:
            type:
              type: string
              enum:
                - volume_split
            data:
              type: array
              items:
                $ref: '#/components/schemas/ConnectorVolumeSplit'
      discriminator:
        propertyName: type
    Connector:
      type: string
      enum:
        - straumur
        - valitor
        - teya
        - adyenplatform
        - phonypay
        - fauxpay
        - pretendpay
        - stripe_test
        - adyen_test
        - checkout_test
        - paypal_test
        - aci
        - adyen
        - airwallex
        - authorizedotnet
        - bambora
        - bamboraapac
        - bankofamerica
        - billwerk
        - bitpay
        - bluesnap
        - boku
        - braintree
        - cashtocode
        - chargebee
        - checkout
        - coinbase
        - coingate
        - cryptopay
        - ctp_mastercard
        - ctp_visa
        - cybersource
        - datatrans
        - deutschebank
        - digitalvirgo
        - dlocal
        - ebanx
        - elavon
        - fiserv
        - fiservemea
        - fiuu
        - forte
        - getnet
        - globalpay
        - globepay
        - gocardless
        - gpayments
        - hipay
        - helcim
        - inespay
        - iatapay
        - itaubank
        - jpmorgan
        - juspaythreedsserver
        - klarna
        - mifinity
        - mollie
        - moneris
        - multisafepay
        - netcetera
        - nexinets
        - nexixpay
        - nmi
        - nomupay
        - noon
        - novalnet
        - nuvei
        - opennode
        - paybox
        - payme
        - payone
        - paypal
        - paystack
        - payu
        - placetopay
        - powertranz
        - prophetpay
        - rapyd
        - razorpay
        - recurly
        - redsys
        - shift4
        - square
        - stax
        - stripe
        - stripebilling
        - taxjar
        - threedsecureio
        - trustpay
        - tsys
        - volt
        - wellsfargo
        - wise
        - worldline
        - worldpay
        - signifyd
        - plaid
        - riskified
        - xendit
        - zen
        - zsl
    CaptureMethod:
      type: string
      description: >-
        Default value if not passed is set to 'automatic' which results in Auth
        and Capture in one single API request. Pass 'manual' or
        'manual_multiple' in case you want do a separate Auth and Capture by
        first authorizing and placing a hold on your customer's funds so that
        you can use the Payments/Capture endpoint later to capture the
        authorized amount. Pass 'manual' if you want to only capture the amount
        later once or 'manual_multiple' if you want to capture the funds
        multiple times later. Both 'manual' and 'manual_multiple' are only
        supported by a specific list of processors
      enum:
        - automatic
        - manual
        - manual_multiple
        - scheduled
        - sequential_automatic
    AuthenticationType:
      type: string
      description: >-
        Pass this parameter to force 3DS or non 3DS auth for this payment. Some
        connectors will still force 3DS auth even in case of passing
        'no_three_ds' here and vice versa. Default value is 'no_three_ds' if not
        set
      enum:
        - three_ds
        - no_three_ds
    Address:
      type: object
      properties:
        address:
          allOf:
            - $ref: '#/components/schemas/AddressDetails'
          nullable: true
        phone:
          allOf:
            - $ref: '#/components/schemas/PhoneDetails'
          nullable: true
        email:
          type: string
          nullable: true
      additionalProperties: false
    CustomerDetails:
      type: object
      description: >-
        Passing this object creates a new customer or attaches an existing
        customer to the payment
      required:
        - id
      properties:
        id:
          type: string
          description: The identifier for the customer.
          example: cus_y3oqhf46pyzuxjbcn2giaqnb44
          maxLength: 64
          minLength: 1
        name:
          type: string
          description: The customer's name
          example: John Doe
          nullable: true
          maxLength: 255
        email:
          type: string
          description: The customer's email address
          example: johntest@test.com
          nullable: true
          maxLength: 255
        phone:
          type: string
          description: The customer's phone number
          example: '9123456789'
          nullable: true
          maxLength: 10
        phone_country_code:
          type: string
          description: The country code for the customer's phone number
          example: '+1'
          nullable: true
          maxLength: 2
    FutureUsage:
      type: string
      description: >-
        Indicates that you intend to make future payments with the payment
        methods used for this Payment. Providing this parameter will attach the
        payment method to the Customer, if present, after the Payment is
        confirmed and any required actions from the user are complete.

        - On_session - Payment method saved only at Vaultera Switch when consent
        is provided by the user. CVV will asked during the returning user
        payment

        - Off_session - Payment method saved at both Vaultera Switch and
        Processor when consent is provided by the user. No input is required
        during the returning user payment.
      enum:
        - off_session
        - on_session
    PaymentMethodDataRequest:
      allOf:
        - allOf:
            - $ref: '#/components/schemas/PaymentMethodData'
          nullable: true
        - type: object
          properties:
            billing:
              allOf:
                - $ref: '#/components/schemas/Address'
              nullable: true
      description: The payment method information provided for making a payment
    PaymentMethod:
      type: string
      description: 'Indicates the type of payment method. Eg: ''card'', ''wallet'', etc.'
      enum:
        - card
        - card_redirect
        - pay_later
        - wallet
        - bank_redirect
        - bank_transfer
        - crypto
        - bank_debit
        - reward
        - real_time_payment
        - upi
        - voucher
        - gift_card
        - open_banking
        - mobile_payment
    OrderDetailsWithAmount:
      type: object
      required:
        - product_name
        - quantity
        - amount
      properties:
        product_name:
          type: string
          description: Name of the product that is being purchased
          example: shirt
          maxLength: 255
        quantity:
          type: integer
          format: int32
          description: The quantity of the product to be purchased
          example: 1
          minimum: 0
        amount:
          type: integer
          format: int64
          description: the amount per quantity of product
        tax_rate:
          type: number
          format: double
          description: tax rate applicable to the product
          nullable: true
        total_tax_amount:
          type: integer
          format: int64
          description: total tax amount applicable to the product
          nullable: true
        requires_shipping:
          type: boolean
          nullable: true
        product_img_link:
          type: string
          description: The image URL of the product
          nullable: true
        product_id:
          type: string
          description: ID of the product that is being purchased
          nullable: true
        category:
          type: string
          description: Category of the product that is being purchased
          nullable: true
        sub_category:
          type: string
          description: Sub category of the product that is being purchased
          nullable: true
        brand:
          type: string
          description: Brand of the product that is being purchased
          nullable: true
        product_type:
          allOf:
            - $ref: '#/components/schemas/ProductType'
          nullable: true
        product_tax_code:
          type: string
          description: The tax code for the product
          nullable: true
    MandateData:
      type: object
      description: >-
        Passing this object during payments creates a mandate. The mandate_type
        sub object is passed by the server.
      properties:
        update_mandate_id:
          type: string
          description: A way to update the mandate's payment method details
          nullable: true
        customer_acceptance:
          allOf:
            - $ref: '#/components/schemas/CustomerAcceptance'
          nullable: true
        mandate_type:
          allOf:
            - $ref: '#/components/schemas/MandateType'
          nullable: true
      additionalProperties: false
    CustomerAcceptance:
      type: object
      description: >-
        This "CustomerAcceptance" object is passed during Payments-Confirm
        request, it enlists the type, time, and mode of acceptance properties
        related to an acceptance done by the customer. The customer_acceptance
        sub object is usually passed by the SDK or client.
      required:
        - acceptance_type
      properties:
        acceptance_type:
          $ref: '#/components/schemas/AcceptanceType'
        accepted_at:
          type: string
          format: date-time
          description: Specifying when the customer acceptance was provided
          example: '2022-09-10T10:11:12Z'
          nullable: true
        online:
          allOf:
            - $ref: '#/components/schemas/OnlineMandate'
          nullable: true
      additionalProperties: false
    BrowserInformation:
      type: object
      description: Browser information to be used for 3DS 2.0
      properties:
        color_depth:
          type: integer
          format: int32
          description: Color depth supported by the browser
          nullable: true
          minimum: 0
        java_enabled:
          type: boolean
          description: Whether java is enabled in the browser
          nullable: true
        java_script_enabled:
          type: boolean
          description: Whether javascript is enabled in the browser
          nullable: true
        language:
          type: string
          description: Language supported
          nullable: true
        screen_height:
          type: integer
          format: int32
          description: The screen height in pixels
          nullable: true
          minimum: 0
        screen_width:
          type: integer
          format: int32
          description: The screen width in pixels
          nullable: true
          minimum: 0
        time_zone:
          type: integer
          format: int32
          description: Time zone of the client
          nullable: true
        ip_address:
          type: string
          description: Ip address of the client
          nullable: true
        accept_header:
          type: string
          description: List of headers that are accepted
          example: >-
            text/html,application/xhtml+xml,application/xml;q=0.9,image/webp,image/apng,*/*;q=0.8
          nullable: true
        user_agent:
          type: string
          description: User-agent of the browser
          nullable: true
        os_type:
          type: string
          description: The os type of the client device
          nullable: true
        os_version:
          type: string
          description: The os version of the client device
          nullable: true
        device_model:
          type: string
          description: The device model of the client
          nullable: true
    PaymentExperience:
      type: string
      description: >-
        To indicate the type of payment experience that the customer would go
        through
      enum:
        - redirect_to_url
        - invoke_sdk_client
        - display_qr_code
        - one_click
        - link_wallet
        - invoke_payment_app
        - display_wait_screen
        - collect_otp
    PaymentMethodType:
      type: string
      description: >-
        Indicates the sub type of payment method. Eg: 'google_pay' & 'apple_pay'
        for wallets.
      enum:
        - ach
        - affirm
        - afterpay_clearpay
        - alfamart
        - ali_pay
        - ali_pay_hk
        - alma
        - amazon_pay
        - apple_pay
        - atome
        - bacs
        - bancontact_card
        - becs
        - benefit
        - bizum
        - blik
        - boleto
        - bca_bank_transfer
        - bni_va
        - bri_va
        - card_redirect
        - cimb_va
        - classic
        - credit
        - crypto_currency
        - cashapp
        - dana
        - danamon_va
        - debit
        - duit_now
        - efecty
        - eft
        - eps
        - fps
        - evoucher
        - giropay
        - givex
        - google_pay
        - go_pay
        - gcash
        - ideal
        - interac
        - indomaret
        - klarna
        - kakao_pay
        - local_bank_redirect
        - mandiri_va
        - knet
        - mb_way
        - mobile_pay
        - momo
        - momo_atm
        - multibanco
        - online_banking_thailand
        - online_banking_czech_republic
        - online_banking_finland
        - online_banking_fpx
        - online_banking_poland
        - online_banking_slovakia
        - oxxo
        - pago_efectivo
        - permata_bank_transfer
        - open_banking_uk
        - pay_bright
        - paypal
        - paze
        - pix
        - pay_safe_card
        - przelewy24
        - prompt_pay
        - pse
        - red_compra
        - red_pagos
        - samsung_pay
        - sepa
        - sepa_bank_transfer
        - sofort
        - swish
        - touch_n_go
        - trustly
        - twint
        - upi_collect
        - upi_intent
        - vipps
        - viet_qr
        - venmo
        - walley
        - we_chat_pay
        - seven_eleven
        - lawson
        - mini_stop
        - family_mart
        - seicomart
        - pay_easy
        - local_bank_transfer
        - mifinity
        - open_banking_pis
        - direct_carrier_billing
        - instant_bank_transfer
    CountryAlpha2:
      type: string
      enum:
        - AF
        - AX
        - AL
        - DZ
        - AS
        - AD
        - AO
        - AI
        - AQ
        - AG
        - AR
        - AM
        - AW
        - AU
        - AT
        - AZ
        - BS
        - BH
        - BD
        - BB
        - BY
        - BE
        - BZ
        - BJ
        - BM
        - BT
        - BO
        - BQ
        - BA
        - BW
        - BV
        - BR
        - IO
        - BN
        - BG
        - BF
        - BI
        - KH
        - CM
        - CA
        - CV
        - KY
        - CF
        - TD
        - CL
        - CN
        - CX
        - CC
        - CO
        - KM
        - CG
        - CD
        - CK
        - CR
        - CI
        - HR
        - CU
        - CW
        - CY
        - CZ
        - DK
        - DJ
        - DM
        - DO
        - EC
        - EG
        - SV
        - GQ
        - ER
        - EE
        - ET
        - FK
        - FO
        - FJ
        - FI
        - FR
        - GF
        - PF
        - TF
        - GA
        - GM
        - GE
        - DE
        - GH
        - GI
        - GR
        - GL
        - GD
        - GP
        - GU
        - GT
        - GG
        - GN
        - GW
        - GY
        - HT
        - HM
        - VA
        - HN
        - HK
        - HU
        - IS
        - IN
        - ID
        - IR
        - IQ
        - IE
        - IM
        - IL
        - IT
        - JM
        - JP
        - JE
        - JO
        - KZ
        - KE
        - KI
        - KP
        - KR
        - KW
        - KG
        - LA
        - LV
        - LB
        - LS
        - LR
        - LY
        - LI
        - LT
        - LU
        - MO
        - MK
        - MG
        - MW
        - MY
        - MV
        - ML
        - MT
        - MH
        - MQ
        - MR
        - MU
        - YT
        - MX
        - FM
        - MD
        - MC
        - MN
        - ME
        - MS
        - MA
        - MZ
        - MM
        - NA
        - NR
        - NP
        - NL
        - NC
        - NZ
        - NI
        - NE
        - NG
        - NU
        - NF
        - MP
        - 'NO'
        - OM
        - PK
        - PW
        - PS
        - PA
        - PG
        - PY
        - PE
        - PH
        - PN
        - PL
        - PT
        - PR
        - QA
        - RE
        - RO
        - RU
        - RW
        - BL
        - SH
        - KN
        - LC
        - MF
        - PM
        - VC
        - WS
        - SM
        - ST
        - SA
        - SN
        - RS
        - SC
        - SL
        - SG
        - SX
        - SK
        - SI
        - SB
        - SO
        - ZA
        - GS
        - SS
        - ES
        - LK
        - SD
        - SR
        - SJ
        - SZ
        - SE
        - CH
        - SY
        - TW
        - TJ
        - TZ
        - TH
        - TL
        - TG
        - TK
        - TO
        - TT
        - TN
        - TR
        - TM
        - TC
        - TV
        - UG
        - UA
        - AE
        - GB
        - UM
        - UY
        - UZ
        - VU
        - VE
        - VN
        - VG
        - VI
        - WF
        - EH
        - YE
        - ZM
        - ZW
        - US
    MerchantConnectorDetailsWrap:
      type: object
      description: Merchant connector details used to make payments.
      required:
        - creds_identifier
      properties:
        creds_identifier:
          type: string
          description: >-
            Creds Identifier is to uniquely identify the credentials. Do not
            send any sensitive info, like encoded_data in this field. And do not
            send the string "null".
        encoded_data:
          allOf:
            - $ref: '#/components/schemas/MerchantConnectorDetails'
          nullable: true
    ConnectorMetadata:
      type: object
      description: >-
        Some connectors like Apple Pay, Airwallex and Noon might require some
        additional information, find specific details in the child attributes
        below.
      properties:
        apple_pay:
          allOf:
            - $ref: '#/components/schemas/ApplepayConnectorMetadataRequest'
          nullable: true
        airwallex:
          allOf:
            - $ref: '#/components/schemas/AirwallexData'
          nullable: true
        noon:
          allOf:
            - $ref: '#/components/schemas/NoonData'
          nullable: true
        braintree:
          allOf:
            - $ref: '#/components/schemas/BraintreeData'
          nullable: true
    PaymentCreatePaymentLinkConfig:
      allOf:
        - allOf:
            - $ref: '#/components/schemas/PaymentLinkConfigRequest'
          nullable: true
        - type: object
      description: Configure a custom payment link for the particular payment
    RequestSurchargeDetails:
      type: object
      description: Details of surcharge applied on this payment, if applicable
      required:
        - surcharge_amount
      properties:
        surcharge_amount:
          type: integer
          format: int64
          example: 6540
        tax_amount:
          allOf:
            - $ref: '#/components/schemas/MinorUnit'
          nullable: true
    PaymentType:
      type: string
      description: >-
        The type of the payment that differentiates between normal and various
        types of mandate payments. Use 'setup_mandate' in case of zero auth
        flow.
      enum:
        - normal
        - new_mandate
        - setup_mandate
        - recurring_mandate
    RecurringDetails:
      oneOf:
        - type: object
          required:
            - type
            - data
          properties:
            type:
              type: string
              enum:
                - mandate_id
            data:
              type: string
        - type: object
          required:
            - type
            - data
          properties:
            type:
              type: string
              enum:
                - payment_method_id
            data:
              type: string
        - type: object
          required:
            - type
            - data
          properties:
            type:
              type: string
              enum:
                - processor_payment_token
            data:
              $ref: '#/components/schemas/ProcessorPaymentToken'
        - type: object
          required:
            - type
            - data
          properties:
            type:
              type: string
              enum:
                - network_transaction_id_and_card_details
            data:
              $ref: '#/components/schemas/NetworkTransactionIdAndCardDetails'
      description: Details required for recurring payment
      discriminator:
        propertyName: type
    SplitPaymentsRequest:
      oneOf:
        - type: object
          required:
            - stripe_split_payment
          properties:
            stripe_split_payment:
              $ref: '#/components/schemas/StripeSplitPaymentRequest'
        - type: object
          required:
            - adyen_split_payment
          properties:
            adyen_split_payment:
              $ref: '#/components/schemas/AdyenSplitData'
        - type: object
          required:
            - xendit_split_payment
          properties:
            xendit_split_payment:
              $ref: '#/components/schemas/XenditSplitRequest'
      description: >-
        Fee information for Split Payments to be charged on the payment being
        collected
    ScaExemptionType:
      type: string
      description: SCA Exemptions types available for authentication
      enum:
        - low_value
        - transaction_risk_analysis
    CtpServiceDetails:
      type: object
      properties:
        merchant_transaction_id:
          type: string
          description: merchant transaction id
          nullable: true
        correlation_id:
          type: string
          description: network transaction correlation id
          nullable: true
        x_src_flow_id:
          type: string
          description: session transaction flow id
          nullable: true
        provider:
          allOf:
            - $ref: '#/components/schemas/CtpServiceProvider'
          nullable: true
        encypted_payload:
          type: string
          description: Encrypted payload
          nullable: true
    ThreeDsCompletionIndicator:
      type: string
      enum:
        - 'Y'
        - 'N'
        - U
    IntentStatus:
      type: string
      description: The status of the current payment that was made
      enum:
        - succeeded
        - failed
        - cancelled
        - processing
        - requires_customer_action
        - requires_merchant_action
        - requires_payment_method
        - requires_confirmation
        - requires_capture
        - partially_captured
        - partially_captured_and_capturable
    RefundResponse:
      type: object
      required:
        - refund_id
        - payment_id
        - amount
        - currency
        - status
        - connector
      properties:
        refund_id:
          type: string
          description: Unique Identifier for the refund
        payment_id:
          type: string
          description: The payment id against which refund is initiated
        amount:
          type: integer
          format: int64
          description: >-
            The refund amount, which should be less than or equal to the total
            payment amount. Amount for the payment in lowest denomination of the
            currency. (i.e) in cents for USD denomination, in paisa for INR
            denomination etc
          example: 6540
          minimum: 100
        currency:
          type: string
          description: The three-letter ISO currency code
        status:
          $ref: '#/components/schemas/RefundStatus'
        reason:
          type: string
          description: >-
            An arbitrary string attached to the object. Often useful for
            displaying to users and your customer support executive
          nullable: true
        metadata:
          type: object
          description: >-
            You can specify up to 50 keys, with key names up to 40 characters
            long and values up to 500 characters long. Metadata is useful for
            storing additional, structured information on an object
          nullable: true
        error_message:
          type: string
          description: The error message
          nullable: true
        error_code:
          type: string
          description: The code for the error
          nullable: true
        unified_code:
          type: string
          description: >-
            Error code unified across the connectors is received here if there
            was an error while calling connector
          nullable: true
        unified_message:
          type: string
          description: >-
            Error message unified across the connectors is received here if
            there was an error while calling connector
          nullable: true
        created_at:
          type: string
          format: date-time
          description: The timestamp at which refund is created
          nullable: true
        updated_at:
          type: string
          format: date-time
          description: The timestamp at which refund is updated
          nullable: true
        connector:
          type: string
          description: The connector used for the refund and the corresponding payment
          example: stripe
        profile_id:
          type: string
          description: The id of business profile for this refund
          nullable: true
        merchant_connector_id:
          type: string
          description: >-
            The merchant_connector_id of the processor through which this
            payment went through
          nullable: true
        split_refunds:
          allOf:
            - $ref: '#/components/schemas/SplitRefund'
          nullable: true
        issuer_error_code:
          type: string
          description: Error code received from the issuer in case of failed refunds
          nullable: true
        issuer_error_message:
          type: string
          description: Error message received from the issuer in case of failed refunds
          nullable: true
    DisputeResponsePaymentsRetrieve:
      type: object
      required:
        - dispute_id
        - dispute_stage
        - dispute_status
        - connector_status
        - connector_dispute_id
        - created_at
      properties:
        dispute_id:
          type: string
          description: The identifier for dispute
        dispute_stage:
          $ref: '#/components/schemas/DisputeStage'
        dispute_status:
          $ref: '#/components/schemas/DisputeStatus'
        connector_status:
          type: string
          description: Status of the dispute sent by connector
        connector_dispute_id:
          type: string
          description: Dispute id sent by connector
        connector_reason:
          type: string
          description: Reason of dispute sent by connector
          nullable: true
        connector_reason_code:
          type: string
          description: Reason code of dispute sent by connector
          nullable: true
        challenge_required_by:
          type: string
          format: date-time
          description: Evidence deadline of dispute sent by connector
          nullable: true
        connector_created_at:
          type: string
          format: date-time
          description: Dispute created time sent by connector
          nullable: true
        connector_updated_at:
          type: string
          format: date-time
          description: Dispute updated time sent by connector
          nullable: true
        created_at:
          type: string
          format: date-time
          description: Time at which dispute is received
    PaymentAttemptResponse:
      type: object
      required:
        - attempt_id
        - status
        - amount
        - created_at
        - modified_at
      properties:
        attempt_id:
          type: string
          description: Unique identifier for the attempt
        status:
          $ref: '#/components/schemas/AttemptStatus'
        amount:
          type: integer
          format: int64
          description: >-
            The payment attempt amount. Amount for the payment in lowest
            denomination of the currency. (i.e) in cents for USD denomination,
            in paisa for INR denomination etc.,
          example: 6540
        order_tax_amount:
          type: integer
          format: int64
          description: The payment attempt tax_amount.
          example: 6540
          nullable: true
        currency:
          allOf:
            - $ref: '#/components/schemas/Currency'
          nullable: true
        connector:
          type: string
          description: The connector used for the payment
          nullable: true
        error_message:
          type: string
          description: >-
            If there was an error while calling the connector, the error message
            is received here
          nullable: true
        payment_method:
          allOf:
            - $ref: '#/components/schemas/PaymentMethod'
          nullable: true
        connector_transaction_id:
          type: string
          description: A unique identifier for a payment provided by the connector
          nullable: true
        capture_method:
          allOf:
            - $ref: '#/components/schemas/CaptureMethod'
          nullable: true
        authentication_type:
          allOf:
            - $ref: '#/components/schemas/AuthenticationType'
          default: three_ds
          nullable: true
        created_at:
          type: string
          format: date-time
          description: Time at which the payment attempt was created
          example: '2022-09-10T10:11:12Z'
        modified_at:
          type: string
          format: date-time
          description: Time at which the payment attempt was last modified
          example: '2022-09-10T10:11:12Z'
        cancellation_reason:
          type: string
          description: If the payment was cancelled the reason will be provided here
          nullable: true
        mandate_id:
          type: string
          description: >-
            A unique identifier to link the payment to a mandate, can be use
            instead of payment_method_data
          nullable: true
        error_code:
          type: string
          description: >-
            If there was an error while calling the connectors the error code is
            received here
          nullable: true
        payment_token:
          type: string
          description: Provide a reference to a stored payment method
          nullable: true
        connector_metadata:
          description: Additional data related to some connectors
          nullable: true
        payment_experience:
          allOf:
            - $ref: '#/components/schemas/PaymentExperience'
          nullable: true
        payment_method_type:
          allOf:
            - $ref: '#/components/schemas/PaymentMethodType'
          nullable: true
        reference_id:
          type: string
          description: Reference to the payment at connector side
          example: 993672945374576J
          nullable: true
        unified_code:
          type: string
          description: >-
            (This field is not live yet)Error code unified across the connectors
            is received here if there was an error while calling connector
          nullable: true
        unified_message:
          type: string
          description: >-
            (This field is not live yet)Error message unified across the
            connectors is received here if there was an error while calling
            connector
          nullable: true
        client_source:
          type: string
          description: >-
            Value passed in X-CLIENT-SOURCE header during payments confirm
            request by the client
          nullable: true
        client_version:
          type: string
          description: >-
            Value passed in X-CLIENT-VERSION header during payments confirm
            request by the client
          nullable: true
    CaptureResponse:
      type: object
      required:
        - capture_id
        - status
        - amount
        - connector
        - authorized_attempt_id
        - capture_sequence
      properties:
        capture_id:
          type: string
          description: Unique identifier for the capture
        status:
          $ref: '#/components/schemas/CaptureStatus'
        amount:
          type: integer
          format: int64
          description: >-
            The capture amount. Amount for the payment in lowest denomination of
            the currency. (i.e) in cents for USD denomination, in paisa for INR
            denomination etc.,
          example: 6540
        currency:
          allOf:
            - $ref: '#/components/schemas/Currency'
          nullable: true
        connector:
          type: string
          description: The connector used for the payment
        authorized_attempt_id:
          type: string
          description: >-
            Unique identifier for the parent attempt on which this capture is
            made
        connector_capture_id:
          type: string
          description: A unique identifier for this capture provided by the connector
          nullable: true
        capture_sequence:
          type: integer
          format: int32
          description: >-
            Sequence number of this capture, in the series of captures made for
            the parent attempt
        error_message:
          type: string
          description: >-
            If there was an error while calling the connector the error message
            is received here
          nullable: true
        error_code:
          type: string
          description: >-
            If there was an error while calling the connectors the code is
            received here
          nullable: true
        error_reason:
          type: string
          description: >-
            If there was an error while calling the connectors the reason is
            received here
          nullable: true
        reference_id:
          type: string
          description: Reference to the capture at connector side
          nullable: true
    PaymentMethodDataResponseWithBilling:
      allOf:
        - allOf:
            - $ref: '#/components/schemas/PaymentMethodDataResponse'
          nullable: true
        - type: object
          properties:
            billing:
              allOf:
                - $ref: '#/components/schemas/Address'
              nullable: true
    NextActionData:
      oneOf:
        - type: object
          description: Contains the url for redirection flow
          required:
            - redirect_to_url
            - type
          properties:
            redirect_to_url:
              type: string
            type:
              type: string
              enum:
                - redirect_to_url
        - type: object
          description: >-
            Informs the next steps for bank transfer and also contains the
            charges details (ex: amount received, amount charged etc)
          required:
            - bank_transfer_steps_and_charges_details
            - type
          properties:
            bank_transfer_steps_and_charges_details:
              $ref: '#/components/schemas/BankTransferNextStepsData'
            type:
              type: string
              enum:
                - display_bank_transfer_information
        - type: object
          description: Contains third party sdk session token response
          required:
            - type
          properties:
            session_token:
              allOf:
                - $ref: '#/components/schemas/SessionToken'
              nullable: true
            type:
              type: string
              enum:
                - third_party_sdk_session_token
        - type: object
          description: Contains url for Qr code image, this qr code has to be shown in sdk
          required:
            - image_data_url
            - qr_code_url
            - type
          properties:
            image_data_url:
              type: string
              description: Vaultera Switch generated image data source url
            display_to_timestamp:
              type: integer
              format: int64
              nullable: true
            qr_code_url:
              type: string
              description: The url for Qr code given by the connector
            display_text:
              type: string
              nullable: true
            border_color:
              type: string
              nullable: true
            type:
              type: string
              enum:
                - qr_code_information
        - type: object
          description: Contains url to fetch Qr code data
          required:
            - qr_code_fetch_url
            - type
          properties:
            qr_code_fetch_url:
              type: string
            type:
              type: string
              enum:
                - fetch_qr_code_information
        - type: object
          description: Contains the download url and the reference number for transaction
          required:
            - voucher_details
            - type
          properties:
            voucher_details:
              type: string
            type:
              type: string
              enum:
                - display_voucher_information
        - type: object
          description: >-
            Contains duration for displaying a wait screen, wait screen with
            timer is displayed by sdk
          required:
            - display_from_timestamp
            - type
          properties:
            display_from_timestamp:
              type: integer
            display_to_timestamp:
              type: integer
              nullable: true
            type:
              type: string
              enum:
                - wait_screen_information
        - type: object
          description: >-
            Contains the information regarding three_ds_method_data submission,
            three_ds authentication, and authorization flows
          required:
            - three_ds_data
            - type
          properties:
            three_ds_data:
              $ref: '#/components/schemas/ThreeDsData'
            type:
              type: string
              enum:
                - three_ds_invoke
        - type: object
          required:
            - next_action_data
            - type
          properties:
            next_action_data:
              $ref: '#/components/schemas/SdkNextActionData'
            type:
              type: string
              enum:
                - invoke_sdk_client
        - type: object
          description: Contains consent to collect otp for mobile payment
          required:
            - consent_data_required
            - type
          properties:
            consent_data_required:
              $ref: '#/components/schemas/MobilePaymentConsent'
            type:
              type: string
              enum:
                - collect_otp
        - type: object
          description: Contains data required to invoke hidden iframe
          required:
            - iframe_data
            - type
          properties:
            iframe_data:
              $ref: '#/components/schemas/IframeData'
            type:
              type: string
              enum:
                - invoke_hidden_iframe
      discriminator:
        propertyName: type
    EphemeralKeyCreateResponse:
      type: object
      description: ephemeral_key for the customer_id mentioned
      required:
        - customer_id
        - created_at
        - expires
        - secret
      properties:
        customer_id:
          type: string
          description: customer_id to which this ephemeral key belongs to
          example: cus_y3oqhf46pyzuxjbcn2giaqnb44
          maxLength: 64
          minLength: 1
        created_at:
          type: integer
          format: int64
          description: time at which this ephemeral key was created
        expires:
          type: integer
          format: int64
          description: time at which this ephemeral key would expire
        secret:
          type: string
          description: ephemeral key
    FrmMessage:
      type: object
      description: >-
        frm message is an object sent inside the payments response...when frm is
        invoked, its value is Some(...), else its None
      required:
        - frm_name
      properties:
        frm_name:
          type: string
        frm_transaction_id:
          type: string
          nullable: true
        frm_transaction_type:
          type: string
          nullable: true
        frm_status:
          type: string
          nullable: true
        frm_score:
          type: integer
          format: int32
          nullable: true
        frm_reason:
          nullable: true
        frm_error:
          type: string
          nullable: true
    FeatureMetadata:
      type: object
      description: additional data that might be required by vaultera switch
      properties:
        redirect_response:
          allOf:
            - $ref: '#/components/schemas/RedirectResponse'
          nullable: true
        search_tags:
          type: array
          items:
            type: string
          description: Additional tags to be used for global search
          nullable: true
        apple_pay_recurring_details:
          allOf:
            - $ref: '#/components/schemas/ApplePayRecurringDetails'
          nullable: true
    PaymentLinkResponse:
      type: object
      required:
        - link
        - payment_link_id
      properties:
        link:
          type: string
          description: URL for rendering the open payment link
        secure_link:
          type: string
          description: URL for rendering the secure payment link
          nullable: true
        payment_link_id:
          type: string
          description: Identifier for the payment link
    IncrementalAuthorizationResponse:
      type: object
      required:
        - authorization_id
        - amount
        - status
        - previously_authorized_amount
      properties:
        authorization_id:
          type: string
          description: The unique identifier of authorization
        amount:
          type: integer
          format: int64
          description: Amount the authorization has been made for
          example: 6540
        status:
          $ref: '#/components/schemas/AuthorizationStatus'
        error_code:
          type: string
          description: Error code sent by the connector for authorization
          nullable: true
        error_message:
          type: string
          description: Error message sent by the connector for authorization
          nullable: true
        previously_authorized_amount:
          $ref: '#/components/schemas/MinorUnit'
    ExternalAuthenticationDetailsResponse:
      type: object
      description: Details of external authentication
      required:
        - status
      properties:
        authentication_flow:
          allOf:
            - $ref: '#/components/schemas/DecoupledAuthenticationType'
          nullable: true
        electronic_commerce_indicator:
          type: string
          description: Electronic Commerce Indicator (eci)
          nullable: true
        status:
          $ref: '#/components/schemas/AuthenticationStatus'
        ds_transaction_id:
          type: string
          description: DS Transaction ID
          nullable: true
        version:
          type: string
          description: Message Version
          nullable: true
        error_code:
          type: string
          description: Error Code
          nullable: true
        error_message:
          type: string
          description: Error Message
          nullable: true
    PaymentMethodStatus:
      type: string
      description: Payment Method Status
      enum:
        - active
        - inactive
        - processing
        - awaiting_data
    ConnectorChargeResponseData:
      oneOf:
        - type: object
          required:
            - stripe_split_payment
          properties:
            stripe_split_payment:
              $ref: '#/components/schemas/StripeChargeResponseData'
        - type: object
          required:
            - adyen_split_payment
          properties:
            adyen_split_payment:
              $ref: '#/components/schemas/AdyenSplitData'
        - type: object
          required:
            - xendit_split_payment
          properties:
            xendit_split_payment:
              $ref: '#/components/schemas/XenditChargeResponseData'
      description: Charge Information
    MinorUnit:
      type: integer
      format: int64
      description: This Unit struct represents MinorUnit in which core amount works
    CardDiscovery:
      type: string
      description: Indicates the method by which a card is discovered during a payment
      enum:
        - manual
        - saved_card
        - click_to_pay
    RoutableConnectorChoice:
      type: object
      description: Routable Connector chosen for a payment
      required:
        - connector
      properties:
        connector:
          $ref: '#/components/schemas/RoutableConnectors'
        merchant_connector_id:
          type: string
          nullable: true
    ConnectorVolumeSplit:
      type: object
      required:
        - connector
        - split
      properties:
        connector:
          $ref: '#/components/schemas/RoutableConnectorChoice'
        split:
          type: integer
          format: int32
          minimum: 0
    AddressDetails:
      type: object
      description: Address details
      properties:
        city:
          type: string
          description: The address city
          example: New York
          nullable: true
          maxLength: 50
        country:
          allOf:
            - $ref: '#/components/schemas/CountryAlpha2'
          nullable: true
        line1:
          type: string
          description: The first line of the address
          example: 123, King Street
          nullable: true
          maxLength: 200
        line2:
          type: string
          description: The second line of the address
          example: Powelson Avenue
          nullable: true
          maxLength: 50
        line3:
          type: string
          description: The third line of the address
          example: Bridgewater
          nullable: true
          maxLength: 50
        zip:
          type: string
          description: The zip/postal code for the address
          example: '08807'
          nullable: true
          maxLength: 50
        state:
          type: string
          description: The address state
          example: New York
          nullable: true
        first_name:
          type: string
          description: The first name for the address
          example: John
          nullable: true
          maxLength: 255
        last_name:
          type: string
          description: The last name for the address
          example: Doe
          nullable: true
          maxLength: 255
      additionalProperties: false
    PhoneDetails:
      type: object
      properties:
        number:
          type: string
          description: The contact number
          example: '9123456789'
          nullable: true
        country_code:
          type: string
          description: The country code attached to the number
          example: '+1'
          nullable: true
    PaymentMethodData:
      oneOf:
        - type: object
          title: Card
          required:
            - card
          properties:
            card:
              $ref: '#/components/schemas/Card'
        - type: object
          title: CardRedirect
          required:
            - card_redirect
          properties:
            card_redirect:
              $ref: '#/components/schemas/CardRedirectData'
        - type: object
          title: Wallet
          required:
            - wallet
          properties:
            wallet:
              $ref: '#/components/schemas/WalletData'
        - type: object
          title: PayLater
          required:
            - pay_later
          properties:
            pay_later:
              $ref: '#/components/schemas/PayLaterData'
        - type: object
          title: BankRedirect
          required:
            - bank_redirect
          properties:
            bank_redirect:
              $ref: '#/components/schemas/BankRedirectData'
        - type: object
          title: BankDebit
          required:
            - bank_debit
          properties:
            bank_debit:
              $ref: '#/components/schemas/BankDebitData'
        - type: object
          title: BankTransfer
          required:
            - bank_transfer
          properties:
            bank_transfer:
              $ref: '#/components/schemas/BankTransferData'
        - type: object
          title: RealTimePayment
          required:
            - real_time_payment
          properties:
            real_time_payment:
              $ref: '#/components/schemas/RealTimePaymentData'
        - type: object
          title: Crypto
          required:
            - crypto
          properties:
            crypto:
              $ref: '#/components/schemas/CryptoData'
        - type: string
          title: MandatePayment
          enum:
            - mandate_payment
        - type: string
          title: Reward
          enum:
            - reward
        - type: object
          title: Upi
          required:
            - upi
          properties:
            upi:
              $ref: '#/components/schemas/UpiData'
        - type: object
          title: Voucher
          required:
            - voucher
          properties:
            voucher:
              $ref: '#/components/schemas/VoucherData'
        - type: object
          title: GiftCard
          required:
            - gift_card
          properties:
            gift_card:
              $ref: '#/components/schemas/GiftCardData'
        - type: object
          title: CardToken
          required:
            - card_token
          properties:
            card_token:
              $ref: '#/components/schemas/CardToken'
        - type: object
          title: OpenBanking
          required:
            - open_banking
          properties:
            open_banking:
              $ref: '#/components/schemas/OpenBankingData'
        - type: object
          title: MobilePayment
          required:
            - mobile_payment
          properties:
            mobile_payment:
              $ref: '#/components/schemas/MobilePaymentData'
    ProductType:
      type: string
      enum:
        - physical
        - digital
        - travel
        - ride
        - event
        - accommodation
    MandateType:
      oneOf:
        - type: object
          required:
            - single_use
          properties:
            single_use:
              $ref: '#/components/schemas/MandateAmountData'
        - type: object
          required:
            - multi_use
          properties:
            multi_use:
              allOf:
                - $ref: '#/components/schemas/MandateAmountData'
              nullable: true
    AcceptanceType:
      type: string
      description: This is used to indicate if the mandate was accepted online or offline
      enum:
        - online
        - offline
    OnlineMandate:
      type: object
      required:
        - ip_address
        - user_agent
      properties:
        ip_address:
          type: string
          description: >-
            Ip address of the customer machine from which the mandate was
            created
          example: 123.32.25.123
        user_agent:
          type: string
          description: The user-agent of the customer's browser
      additionalProperties: false
    MerchantConnectorDetails:
      type: object
      properties:
        connector_account_details:
          type: object
          description: >-
            Account details of the Connector. You can specify up to 50 keys,
            with key names up to 40 characters long and values up to 500
            characters long. Useful for storing additional, structured
            information on an object.
          nullable: true
        metadata:
          type: object
          description: >-
            Metadata is useful for storing additional, unstructured information
            on an object.
[...]
